local ParticleSystem = {}
local ParticleSystemConstructor = {}
ParticleSystemConstructor.mt = {__index=ParticleSystem}

function ParticleSystemConstructor.new(o)
    o = o or {}
    setmetatable(o, ParticleSystemConstructor.mt)

    o.particles = {}    

    return o
end

function ParticleSystem:init(proto, num)
    self.particles = {}
    or 1,num do
        self.particles[#self.particles+1] = {
            x=love.math.random(proto.x.min, proto.x.max),
            y=love.math.random(proto.y.min, proto.y.max),
            vx=love.math.random(proto.vx.min, proto.vx.max),
            vy=love.math.random(proto.vy.min, proto.vy.max),
            radius=love.math.random(proto.radius.min, proto.radius.max),
            alive=true
        }
    end
end


function ParticleSystem:update(dt)
    for _,p in ipairs(particles) do
        p.x = p.x + p.vx
        p.y = p.y + p.vy
        p.ttl = p.ttl - dt
        if p.ttl < 0 then
            p.alive = false
        end
    end    
end

function ParticleSystem:getFirstDead()
    for _,p in ipairs(self.particles) do
        if not p.alive then
            return p
        end        
    end
end

function ParticleSystem:draw()
--    for _,p in ipairs(particles) do
--        love.graphics.setColor(p.color.r, p.color.g, p.color.b, (p.maxTtl - p.maxTtl-p.ttl) * 255)
--        love.graphics.rectangle("fill", p.x, p.y, p.radius, p.radius)
--    end    
end


return ParticleSystemConstructor