local State = {}
local StateConstructor = {}
StateConstructor.mt = {__index = State}

function StateConstructor.new(o)
    o = o or {}
    setmetatable(o, StateConstructor.mt)
    return o
end

function State:init(assetManager)
    error("Didn't define init for state!")
end

function State:update(dt)
    error("Didn't define update for state!")
end

function State:draw()
    error("Didn't define draw for state!")
end

function State:keypressed(key, scancode, isrepeat)
    -- do nothing
end

function State:keyreleased(key)
    -- do nothing
end

function State:mousemoved( x, y, dx, dy )
    -- do nothing
end

function State:mousepressed( x, y, button, istouch )
    -- do nothing
end

function State:resize(w, h)
    -- do nothing
end

function State:gamepadaxis( joystick, axis, value )
    -- do nothing
end

function State:gamepadpressed( joystick, button )
    -- do nothing
end

function State:gamepadreleased( joystick, button )
    -- do nothing
end

return StateConstructor