-- A grab bag of useful little functions for procedural animation.

local MathUtil = {


wave = function (time, frequency, amplitude, offset, timeOffset)
    offset = offset or 0
    timeOffset = timeOffset or 0
    return math.sin(time * frequency + timeOffset) * amplitude + offset
end,

squarishWave = function (time, frequency, amplitude, offset, timeOffset, harmonics)
    offset = offset or 0
    timeOffset = timeOffset or 0
    harmonics = harmonics or 2
    local modifiedTime = time * frequency + timeOffset
    local result = math.sin(modifiedTime)
    for i = 1, harmonics do
        local term = 2 * i +1
        result = result + math.sin(modifiedTime * term) / term
    end    
    return result * amplitude + offset
end,

beat = function (time, frequency, amplitude, offset, timeOffset)
    offset = offset or 0
    timeOffset = timeOffset or 0
    local modifiedTime = time * frequency + timeOffset
    return (modifiedTime - math.floor(modifiedTime)) * amplitude + offset
end,

randomRange = function (range)
    return (love.math.random() - 0.5) * range
end

}

return MathUtil