-- Compatibility: Lua-5.1
function split(str, pat)
   local t = {}  -- NOTE: use {n = 0} in Lua-5.0
   local fpat = "(.-)" .. pat
   local last_end = 1
   local s, e, cap = str:find(fpat, 1)
   while s do
      if s ~= 1 or cap ~= "" then
	 table.insert(t,cap)
      end
      last_end = e+1
      s, e, cap = str:find(fpat, last_end)
   end
   if last_end <= #str then
      cap = str:sub(last_end)
      table.insert(t, cap)
   end
   return t
end

-- PITCH SHIFT RANGE is an integer in any value
-- where 0 = no change, 1 = +/-1 octave, 2 = +/-2 octave, etc.
function playSound(sound, pitchShiftRange)
    if enableSound then
        if pitchShiftRange then
            pitchShiftRange = math.abs(pitchShiftRange)
            local octaveShift = pitchShiftRange * (love.math.random() - 0.5) * 2
            local pitchModifier = math.pow(2, octaveShift)
            sound:setPitch(pitchModifier)
        end
        sound:stop()
        sound:play()
    end    
end

return {split=split, playSound=playSound}